

datatype ('a, 'b) altList = NIL | CONS of 'a * ('b, 'a) altList






(*
 * length : ('a, 'a) altList -> int
 * REQUIRES: true
 * ENSURES: length lst ==> the length of lst
 *)
fun length (lst:('a, 'a) altList) : int = 
  (case lst of                                
      NIL => 0
    | CONS (x, xs) => 1 + length xs
  )






(*
 * len : ('a, 'b) altList -> int
 * REQUIRES: true
 * ENSURES: len lst ==> the length of lst
 *)
fun len (lst:('a, 'b) altList) : int = 
  (case lst of 
      NIL => 0
    | CONS (x, xs) => 1 + len2 xs
  )
(*
 * len2 : ('a, 'b) altList -> int
 * REQUIRES: true
 * ENSURES: len2 lst ==> the length of lst
 *)
and len2 (lst:('b, 'a) altList) : int = 
  (case lst of 
      NIL => 0
    | CONS (x, xs) => 1 + len xs
  )





  